<?php

namespace Concrete\Package\OunziwFavoritePages\Block\Favoritelist;

use Concrete\Core\Block\BlockController;
use Concrete\Core\Package\Package;

class Controller extends BlockController
{
    protected $btTable = 'btOunziwFavoritelist';
    protected $btInterfaceWidth = "350";
    protected $btInterfaceHeight = "350";

    protected $btCacheBlockOutput = true;
    protected $btCacheBlockOutputOnPost = true;
    protected $btCacheBlockOutputForRegisteredUsers = true;

    public function getBlockTypeDescription()
    {
        return t("Favorite List");
    }

    public function getBlockTypeName()
    {
        return t("Favorite List");
    }

    public function add() {
        $this->setPagesNum();
    }

    public function edit() {
        $this->setPagesNum();
    }

    protected function setPagesNum(){
        $pkg = Package::getByHandle('ounziw_favorite_pages');
        $pagesNum_raw = $pkg->getConfig()->get('concrete.ounziw_favorite_pages_num');
        $pagesNum = $this->validatePagesNum($pagesNum_raw);
        $this->set('pagesNum', $pagesNum);
    }

    public function registerViewAssets($outputContent = '')
    {
        $this->requireAsset('javascript', 'jquery');
    }

    public static function validatePagesNum($pagesNum) {
        $options = array(
            'options' => array(
                'default' => 5,
                'min_range' => 1,
                'max_range' => 100
            ),
        );
        $var = filter_var($pagesNum, FILTER_VALIDATE_INT, $options);
        return $var;
    }

    public function save($data)
    {
        $PagesNum = $this->validatePagesNum($data['pagesNum']);
        $pkg = Package::getByHandle('ounziw_favorite_pages');
        $pkg->getConfig()->save('concrete.ounziw_favorite_pages_num', $PagesNum);

        parent::save($data);
    }
}